﻿using System;
using System.Windows;
using System.Windows.Controls;
using C1.Silverlight.Data;
using Infragistics;
using Infragistics.Controls.Grids;

namespace SummaryRowsTest
{
  public partial class MainPage : UserControl
  {
		#region Fields (1) 

    private Random _random = new Random();

		#endregion Fields 

		#region Constructors (1) 

    public MainPage()
    {
      InitializeComponent();

      Grid.ItemsSource = CreateTable().DefaultView;
    }

		#endregion Constructors 

		#region Methods (2) 

		// Private Methods (2) 

    private void Button_Click(object sender, RoutedEventArgs e)
    {
      if (Grid.SummaryRowSettings.AllowSummaryRow == SummaryRowLocation.None)
      {
        foreach (Column column in Grid.Columns)
        {
          Grid.SummaryRowSettings.SummaryDefinitionCollection.Add(new SummaryDefinition()
          {
            ColumnKey = column.Key,
            SummaryOperand = new AverageSummaryOperand()
          });

          Grid.SummaryRowSettings.SummaryDefinitionCollection.Add(new SummaryDefinition()
          {
            ColumnKey = column.Key,
            SummaryOperand = new MaximumSummaryOperand()
          });

          Grid.SummaryRowSettings.SummaryDefinitionCollection.Add(new SummaryDefinition()
          {
            ColumnKey = column.Key,
            SummaryOperand = new MinimumSummaryOperand()
          });

          Grid.SummaryRowSettings.SummaryDefinitionCollection.Add(new SummaryDefinition()
          {
            ColumnKey = column.Key,
            SummaryOperand = new CountSummaryOperand()
          });

          Grid.SummaryRowSettings.SummaryDefinitionCollection.Add(new SummaryDefinition()
          {
            ColumnKey = column.Key,
            SummaryOperand = new SumSummaryOperand()
          });
        }

        Grid.SummaryRowSettings.AllowSummaryRow = SummaryRowLocation.Bottom;
      }
      else
      {
        Grid.SummaryRowSettings.SummaryDefinitionCollection.Clear();
        Grid.SummaryRowSettings.AllowSummaryRow = SummaryRowLocation.None;
      }
    }

    private DataTable CreateTable()
    {
      var table = new DataTable();

      var columns = 80;
      var rows = 25;

      for (int i = 0; i < columns; i++)
        table.Columns.Add(string.Concat("d", i), typeof(double));

      for (int i = 0; i < rows; i++)
      {
        var row = table.NewRow();

        for (int j = 0; j < columns; j++)
        {
          var columnName = string.Concat("d", j);

          row[columnName] = Math.Round(_random.NextDouble(), 1);
        }

        table.Rows.Add(row);
      }

      return table;
    }

		#endregion Methods 
  }
}
